# dusche.py

from grafikfenster import *
from math import radians
from moebel import Moebel

### ---------------------------------------------------
class Dusche(Moebel):
    """Klasse Dusche
    ermoeglicht das Zeichnen und Bearbeiten eines
    Dusche-Symbols fuer den Raumplaner"""
    
    def __init__(self,
                 xPos=240,
                 yPos=440,
                 breite=80,
                 tiefe=80,
                 winkel=0,
                 farbe="BLACK",
                 fuellfarbe="GRAY",
                 sichtbar=True):
        """Konstruktor mit vordefinierten Parametern
        Konstruktor der Oberklasse aufrufen!"""
        Moebel.__init__(self, xPos, yPos, breite, tiefe, winkel, farbe, fuellfarbe, sichtbar)
        
    def GibFiguren(self):
        """definiert die zu zeichnende Figur"""
        paths = []

        # lokale Variable zur Schreibvereinfachung
        b, t = self.GibBreite(), self.GibTiefe()
        path1 = self.GibZeichenPfad()
        path1.AddRectangle(0, 0, b, t)
        paths.append(self.Transformiere(path1))
        path2 = self.GibZeichenPfad()
        path2.AddRectangle(0.1*b, 0.1*t, 0.8*b, 0.8*t)
        paths.append(self.Transformiere(path2))
        path3 = self.GibZeichenPfad()
        path3.AddEllipse(0.7*b, 0.7*t, 0.1*b, 0.1*t)
        paths.append(self.Transformiere(path3))

        return paths


### ---------------------------------------------------
class DuscheApp(wx.App):
    """Test-Anwendung speziell fuer Dusche"""
    def OnInit(self):
        self.fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        self.fenster.panel.Refresh()
        self.fenster.ZeigeShellFrame()
        #self.fenster.ZeigeFillingFrame()
        self.TestAnwendung()
        return True

    def TestAnwendung(self):
        """Allein fuer die Testanwendung:"""
        global dusche
        dusche=Dusche(sichtbar=True)
        
### ---------------------------------------------------
if __name__ == '__main__':
    app = DuscheApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
