# grundriss.py
##
 # Ein Grundriss fuer den Raumplaner
 # 
 # @author Claus Albowski
 # @version 3'2021
 #
from grafikfenster import *
from math import pi,radians
from moebel import Moebel

### ---------------------------------------------------
class Grundriss (Moebel):

    def __init__(self,
                 xPos = 20,
                 yPos = 20,
                 breite=500,
                 tiefe=500,
                 winkel=0,
                 farbe="BLACK",
                 fuellfarbe=None,
                 sichtbar=True):
        Moebel.__init__(self, xPos, yPos, breite, tiefe, winkel, farbe, fuellfarbe, sichtbar)
        
    def GibFiguren(self):
        path = self.GibZeichenPfad()

        # lokale Variable zur Schreibvereinfachung
        b, t = self.GibBreite(), self.GibTiefe()
        path.AddRectangle(0, 0, b, t) # aussen
        path.AddRectangle(10, 10, b-20, t-20) # innen
        path.AddRectangle(b/2-40, t-10, 80, 10) # Fenster
        path.AddRectangle(10, 200, -10, -80) # Tueröffnung
        path.AddRectangle(10, 200, 80, 2) # Tuer
        path.AddArc(10, 200, 80, 0, -pi*90/180, False) # Tuerbogen
        
        return (self.Transformiere(path),)


### ---------------------------------------------------
class GrundrissApp(wx.App):
    """Test-Anwendung speziell fuer Grundriss"""
    def OnInit(self):
        self.fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        self.fenster.ZeigeShellFrame()
        #self.fenster.ZeigeFillingFrame()
        self.TestAnwendung()
        return True

    def TestAnwendung(self):
        """Allein fuer die Testanwendung:"""
        global grundriss
        grundriss=Grundriss()
        
### ---------------------------------------------------
if __name__ == '__main__':
    app = GrundrissApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
