# sofa.py

from grafikfenster import *
from math import radians
from moebel import Moebel

### ---------------------------------------------------
class Sofa(Moebel):
    """Klasse Sofa
    ermoeglicht das Zeichnen und Bearbeiten eines
    Sofa-Symbols fuer den Raumplaner"""
    
    def __init__(self,
                 xPos=30,
                 yPos=300,
                 breite=160,
                 tiefe=80,
                 winkel=180,
                 farbe="BROWN",
                 fuellfarbe="SIENNA",
                 sichtbar=True):
        """Konstruktor mit vordefinierten Parametern
        Konstruktor der Oberklasse aufrufen!"""
        Moebel.__init__(self, xPos, yPos, breite, tiefe, winkel, farbe, fuellfarbe, sichtbar)
        
    def GibFiguren(self):
        """definiert die zu zeichnende Figur"""
        paths = []

        # lokale Variable zur Schreibvereinfachung
        b, t = self.GibBreite(), self.GibTiefe()
        path1 = self.GibZeichenPfad()
        path1.AddRectangle(0, 0, b, t)
        paths.append(self.Transformiere(path1))
        path2 = self.GibZeichenPfad()
        path2.AddRectangle(t/4.0, t/4.0, b/2.0-t/4.0-1, 3*t/4.0)
        paths.append(self.Transformiere(path2))
        path3 = self.GibZeichenPfad()
        path3.AddRectangle(b/2.0+1, t/4.0, b/2.0-t/4.0-1, 3*t/4.0)
        paths.append(self.Transformiere(path3))

        return paths


### ---------------------------------------------------
class SofaApp(wx.App):
    """Test-Anwendung speziell fuer Sofa"""
    def OnInit(self):
        self.fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        self.fenster.panel.Refresh()
        self.fenster.ZeigeShellFrame()
        #self.fenster.ZeigeFillingFrame()
        self.TestAnwendung()
        return True

    def TestAnwendung(self):
        """Allein fuer die Testanwendung:"""
        global sofa
        sofa=Sofa(sichtbar=True)
        
### ---------------------------------------------------
if __name__ == '__main__':
    app = SofaApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
